/**
 * @author            : Viktor Bogdan
 * @last modified on  : 07-02-2021
 * @last modified by  : Viktor Bogdan
 * Ver   Date         Author          Modification
 * 1.0   07-02-2021   Viktor Bogdan   Initial Version
 **/
trigger ContactTriggerSec6 on Contact(before insert, before update, after insert, after update) {
  /*
      1. Создайте апекс триггер на объекте Contact . Логика его работы должна быть такова, что при
      создании нового контакта с именем Rick и фамилией Sanchez, автоматически должен
      создаваться еще и Морти (новый контакт с именем Morty и фамилийе Smith ).
      */
  // ----------------------------------------------------------------------------------------------
  //   if (Trigger.isAfter && Trigger.isInsert) {
  //     RickAndMortyHandler.addMortyToEveryRick(Trigger.new);
  //   }
  // ----------------------------------------------------------------------------------------------
  /*
      2. Обновите свой триггер так, чтобы когда для нового контакта с именем Rick и фамилией
      Sanchez, автоматически создается Морти (новый контакт с именем Morty и фамилийе Smith ),
      у Морти поле MyRick заполняется значением Id Rick'а для которого он создан.
      
      Кроме того, обновите свой триггер так, чтобы когда создается или обновляется контакт с
      именем Morty и фамилией Smith, проверяется заполнено ли поле MyRick. Если MyRick пустое,
      то значение checkbox SadMorty должно стать true, если MyRick не пустое, то значение
      SadMorty = false.
      */
  // ----------------------------------------------------------------------------------------------
  // if ((Trigger.isBefore && Trigger.isUpdate) || (Trigger.isBefore && Trigger.isInsert)) {
  //   RickAndMortyHandler.checkSadMotry(Trigger.new);
  // }
  // ----------------------------------------------------------------------------------------------

  /*
    
     3. Обновите свой триггер так, чтобы при создании Рика, ему больше автоматически не создавался
      Морти.
      Логика SadMorty чекбокса должна остаться неизменной.
      Обновите свой триггер так, чтобы при инсерте в базу данных списка контактов, каждому
      Морти в этом списке был приписан один Рик (в поле MyRick ) из этого же списка. Если Морти
      не хватило Рика - он остается без Рика.
    */
  // ----------------------------------------------------------------------------------------------
  //   if (Trigger.isAfter && Trigger.isInsert) {
  //     System.debug('Trigger.isAfter && Trigger.isInsert');
  //     System.debug('' + Trigger.new[0].ID);
  //     RickAndMortyHandler.addRickToMorty(Trigger.new);
  //   }
  // ----------------------------------------------------------------------------------------------
  /*
    4. Обновите свой триггер так, чтобы при создании нового Морти, ему приписывался свободный
    Рик (из создаваемых сейчас или уже ранее созданных), т.е. Рик, который не приписан ни к
    одному Морти.
    
    */
  // ----------------------------------------------------------------------------------------------
  //   if (Trigger.isAfter && Trigger.isInsert) {
  //     RickAndMortyHandler.addFreeRickToMorty(Trigger.new);
  //   }
  // ----------------------------------------------------------------------------------------------
  /*

    3. Создайте триггер на объекте Contact, который при создании
    контакта, будет вытягивать все существующие Аккаунты с
    созданным выше полем(Activity типа Date). Далее высчитывается средняя дата
    между всеми из этих Аккаунтов по данному полю и Контакт
    присваивается к Аккаунту с этой датой или датой самой близкой
    к ней. Если есть несколько Аккаунтов с одинаковым значением
    поля Activity, при подсчете средней даты берется только 1
    Случайный Аккаунт. К Аккаунтам, к которым уже был привязан
    Контакт больше нельзя привязать еще 1.

    4. Если контактов больше чем аккаунтов или аккаунтов нет, то поле
    isAccountSet на Контакте выставляется на false, если же Аккаунт
    был успешно присвоен – true.
*/
  // ----------------------------------------------------------------------------------------------
  // if (Trigger.isBefore && Trigger.isInsert) {
  //   ContactTriggerHandlerSec6.addAccountToContact(Trigger.new);
  // }
}
